; ---------------------------------------------------
; multipliziert acc2,acc3 mit acc, Ergebnis in r3,r4,r5
mul16mal8:
	mul	acc3,acc	; -> r1,r0
	clr	r3
	mov	r5,r0	
	mov	r4,r1
	mul	acc2,acc
	add	r4,r0
	adc	r3,r1
	ret
	
; multipliziert acc3,acc4 mit acc,acc2, ergebnis in r3,r4,r5,r6
mul16mal16:
	clr	r3
	clr	r4
	clr	r7
	mul	acc4,acc2	; -> r1,r0
	mov	r5,r1
	mov	r6,r0
	mul	acc3,acc2	; -> r1,r0
	add	r5,r0
	adc	r4,r1
	mul	acc4,acc	; -> r1,r0
	add	r5,r0
	adc	r4,r1
	adc	r3,r7
	mul	acc3,acc	; -> r1,r0
	add	r4,r0
	adc	r3,r1
	ret
	
; Div16d8 dividiert eine 16-Bit-Zahl durch eine 8-Bit-Zahl
;
; lbyte NW Divident
; hbyte HW Divident
; acc2 Hifsregister
; acc Divisor
; acc4 NW Ergebnis
; acc3 HW Ergebnis

; Divieren von hbyte:lbyte durch acc, Ergebnis in acc3,acc4

div16d8:
	push	hbyte
	push	lbyte
	clr 	acc2 		; Leere Hilfsregister
	clr 	acc3 		; Leere Ergebnisregister
	clr 	acc4 		; (Ergebnisregister dient auch als
	inc 	acc4 		; Zhler bis 16! Bit 1 auf 1 setzen)
div8a:
	clc 			; Carry-Bit leeren
	rol 	lbyte 		; nchsthheres Bit des Dividenten
	rol 	hbyte 		; in das Hilfsregister rotieren
	rol 	acc2 		; (entspricht Multipliklation mit 2)
	brcs 	div8b 		; Eine 1 ist herausgerollt, ziehe ab
	cp 	acc2,acc 	; Divisionsergebnis 1 oder 0?
	brcs 	div8c 		; berspringe Subtraktion, wenn kleiner
div8b:
	sub 	acc2,acc	; Subtrahiere Divisor
	sec 			; Setze carry-bit, Ergebnis ist eine 1
	rjmp 	div8d 		; zum Schieben des Ergebnisses
div8c:
	clc 			; Lsche carry-bit, Ergebnis ist eine 0
div8d:
	rol 	acc4 		; Rotiere carry-bit in das Ergebnis
	rol 	acc3
	brcc 	div8a 		; solange Nullen aus dem Ergebnis rotieren:
				; weitermachen
	pop	lbyte
	pop	hbyte
	ret

