; ===================================================
; ANACON
; ===================================================
;
; ANACON verwaltet den ADW.
; AD0: Poti U1, Messwert durch 2, Auflsung 1V
; AD1: Poti U2, Messwert durch 2, Auflsung 1V
; AD2: Poti I1, Messwert je nach (D)leistungsstufe umrechnen, Auflsung 0,01A
; AD3: Poti I2, Messwert je nach (D)leistungsstufe umrechnen, Auflsung 0,01A
; AD4: Temperatursensor Messwert 4 mal aufaddieren 972digit = 100, Auflsung 0,1C
; AD5: Istspannung, Bereich 1kV, Messwert x10, Auflsung 0,1V
; AD5: Istspannung, Bereich 100V, Auflsung 0,1V
; AD7: Iststrom, Bereich 10A, Auflsung 0,01A
; AD8: Iststrom, Bereich 25A, Messwert x10 und durch 4, Auflsung 0,01A


anacon:
	ldi		zl,low(anatab*2)
	ldi		zh,high(anatab*2)
	lds		acc,anasta
	rcall	sprung
	ijmp

anatab:
	.dw    ana0
	.dw    ana1
	.dw    ana2
	.dw    ana3
	.dw    ana4
	.dw    ana5
	.dw    ana6
	.dw    ana7
	.dw    ana8


; AD0: Poti U1
; --------------------------------------

ana0:
	ldi		acc,adrad1			; folgender Mux
	rcall	anainp				; -> acc2,acc3
	lsr		acc2
	ror		acc3
	sts		sollu1,acc2
	sts		sollu1+1,acc3
	rjmp	ananext

; AD1: Poti U2
; --------------------------------------

ana1:
	ldi		acc,adrad2			; folgender Mux
	rcall	anainp				; -> acc2,acc3
	lsr		acc2
	ror		acc3
	sts		sollu2,acc2
	sts		sollu2+1,acc3
	rjmp	ananext
	
; AD2: Poti I1
; --------------------------------------

ana2:
	ldi		acc,adrad3			; folgender Mux
	rcall	anainp				; -> acc2,acc3
	lds		acc,leistungsstufe
	rcall	mul16mal8			;acc2,acc3 * acc = r3,r4,r5
	mov		hbyte,r4
	mov		lbyte,r5
	ldi		acc,5
	rcall	div16d8				; hbyte,lbyte / acc = acc3,acc4
	sts		solli1,acc3
	sts		solli1+1,acc4
	rjmp	ananext
	
; AD3: Poti I2
; --------------------------------------

ana3:
	ldi		acc,adrad4			; folgender Mux
	rcall	anainp				; -> acc2,acc3
	lds		acc,leistungsstufe
	rcall	mul16mal8			;acc2,acc3 * acc = r3,r4,r5
	mov		hbyte,r4
	mov		lbyte,r5
	ldi		acc,5
	rcall	div16d8				; hbyte,lbyte / acc = acc3,acc4
	sts		solli2,acc3
	sts		solli2+1,acc4
	rjmp	ananext
	
; AD4: Temperatursensor

ana4:
	ldi		acc,adrad5			; folgender Mux
	rcall	anainp				; -> acc2,acc3
	ldi		hbyte,high(339)
	ldi		lbyte,low(339)
	sub		acc3,lbyte
	sbc		acc2,hbyte
	ldi		acc,18
	rcall	mul16mal8 		;acc2,acc3 x acc = r3,r4,r5
    mov     hbyte,r4
    mov     lbyte,r5
    ldi     acc,10
    rcall   div16d8         ;  hbyte,lbyte durch acc = acc3,acc4	
	lds		acc,temperatur+2
	tst		acc
	breq	ana4a
	dec		acc
	sts		temperatur+2,acc
	lds		acc,temperatur+4
	add		acc,acc4
	sts		temperatur+4,acc
	lds		acc,temperatur+3
	adc		acc,acc3
	sts		temperatur+3,acc
	rjmp	ananext
ana4a:
	ldi		acc,4
	sts		temperatur+2,acc 		; Zhler setzen
	lds		acc2,temperatur+3        ; ergebnis umladen
	lds		acc3,temperatur+4        ; ergebnis umladen
	lsr		acc2					; durch 4 teilen
	ror		acc3
	lsr		acc2
	ror		acc3
	sts		temperatur,acc2
	sts		temperatur+1,acc3
	clr		acc
	sts		temperatur+3,acc
	sts		temperatur+4,acc
	rjmp	ananext
	
; AD5: Istspannung, Bereich 1kV

ana5:
	ldi		acc,adrad6			; folgender Mux
	rcall	anainp				; -> acc2,acc3
	sts		istu+2,acc2
	sts		istu+3,acc3
	rjmp	ananext
	
; AD6: Istspannung, Bereich 100V

ana6:
	ldi		acc,adrad7			; folgender Mux
	rcall	anainp				; -> acc2,acc3
	sts		istu+4,acc2
	sts		istu+5,acc3
	rcall	istuausgabe			; Ausgabe
	rjmp	ananext
	
; AD7: Iststrom, Bereich 10A

ana7:
	ldi		acc,adrad8			; folgender Mux
	rcall	anainp				; -> acc2,acc3
	sts		isti+2,acc2
	sts		isti+3,acc3
	rjmp	ananext

; AD8: Istspannung, Bereich 100V

ana8:
	ldi		acc,adrad0			; folgender Mux
	rcall	anainp				; -> acc2,acc3
	sts		isti+4,acc2
	sts		isti+5,acc3
	rcall	istiausgabe			; Ausgabe
	clr		acc
	sts		anasta,acc
	ret

; -------

ananext:
	lds		acc,anasta
	inc		acc
	sts		anasta,acc
	ret
	
	
; ------------- UPs ----------------

istuausgabe:
	lds		r3,istu+2     ; 1kV-Bereich	
	lds		r4,istu+3
	lds		r5,istu+4     ; 100V-Bereich
	lds		r6,istu+5
; ber 100V? 100V_Bereich berlaufen?
	ldi		acc,low(510)
	sub		acc,r6
	ldi		acc,high(510)
	sbc		acc,r5
	brcc    istuausg1			; berlaufen
	mov		acc2,r3
	mov		acc3,r4
	ldi		acc,10
	rcall	mul16mal8			; acc2,acc3 x acc = r3,r4,r5
	sts		istu,r4
	sts		istu+1,r5
	ret
istuausg1:
	sts		istu,r5
	sts		istu+1,r6
	ret
	
istiausgabe:
	lds		r3,isti+2		; 10A-Bereich	
	lds		r4,isti+3
	lds		r5,isti+4 		; 25A-Bereich
	lds		r6,isti+5
; ber 10A? 10A_Bereich berlaufen?
	ldi		acc,low(510)
	sub		acc,r4
	ldi		acc,high(510)
	sbc		acc,r3
	brcc    istiausg1			; nicht berlaufen
	mov		acc2,r5
	mov		acc3,r6
	ldi		acc,10              ; mal 10
	rcall	mul16mal8			; acc2,acc3 x acc = r3,r4,r5
	lsr		r4                 	; durch 4
	ror		r5	
	lsr		r4
	ror		r5	
	sts		isti,r4
	sts		isti+1,r5
	ret
istiausg1:
	sts		isti,r3
	sts		isti+1,r4
	ret
		
