; diverse kleine UPs


sprung:
 	lsl	acc
	add	zl,acc
	ldi	acc,0
	adc	zh,acc
	lpm	acc,z+
	lpm
	mov	zl,acc
	mov	zh,r0
	ret
	
; ---------------------------------------------------
; HoleMeldeAdr
; Eingang: Meldetext-Nr in (D)meldungen
; Ausgang: Textadressen in zh:zl

HoleMeldeAdr:
	lds		acc,meldungen
	tst		acc
	breq	hma1
	dec		acc
	ldi		acc2,14
	mul		acc,acc2			; acc,acc2 -> r1,R0 (HW/NW)
	ldi		zl,low(meldetxt*2)
	ldi		zh,high(meldetxt*2)
	add		zl,r0
	adc		zh,r1
    ldi     lcdzeiger,14
	rcall	kopiereCnachD
hma1:
	ret

; ---------------------------------------------------
; KopiereCnachD
; Eingang: textadresse in zh:zl, Stringlnge in (R)lcdzeiger
; Ausgang: (D)lcdpuffer

KopiereCnachD:
	ldi		xl,low(lcdpuffer)
	ldi		xh,high(lcdpuffer)
kopier1:
	lpm		acc,z+
	st		x+,acc
	dec		lcdzeiger
	brne	kopier1
	sbr		merker1,(1<<lcdaktiv)
	ret

; ---------------------------------------------------
; U1SollZumLcdPuffer, setzt den Sollwert vom Poti in den lcdpuffer
; Format: 003V...500V
; Eingang: (D)SollU1  
; Ausgang: (D)lcdpuffer

U1SollZumLcdPuffer:
	lds		acc2,sollu1
	lds		acc3,sollu1+1
	rcall	binasc4    			; acc2,acc3 -> r3,4,5,6
	ldi		xl,low(lcdpuffer)
	ldi		xh,high(lcdpuffer)
	ldi		acc,0x81			; position
	st		x+,acc
	st		x+,r4
	st		x+,r5
	st		x+,r6
	ldi		acc,'V'
	st		x+,acc
	clr		acc
	st		x,acc
	ldi		lcdzeiger,0
	sbr		merker1,(1<<lcdaktiv)
	ret	

; ---------------------------------------------------
; U2SollZumLcdPuffer, setzt den Sollwert vom Poti in den lcdpuffer
; Format: 003V...500V
; Eingang: (D)SollU2
; Ausgang: (D)lcdpuffer

U2SollZumLcdPuffer:
	lds		acc2,sollu2
	lds		acc3,sollu2+1
	rcall	binasc4    			; acc2,acc3 -> r3,4,5,6
	ldi		xl,low(lcdpuffer)
	ldi		xh,high(lcdpuffer)
	ldi		acc,0x84			; position
	st		x+,acc
	ldi		acc,' '
	st		x+,acc
	st		x+,r4
	st		x+,r5
	st		x+,r6
	clr		acc
	st		x,acc
	ldi		lcdzeiger,0
	sbr		merker1,(1<<lcdaktiv)
	ret	

; ---------------------------------------------------
; I1SollZumLcdPuffer,, setzt den Sollwert vom Poti in den lcdpuffer
; Format: 11.23...16.00
; Eingang: (D)SollI1
; Ausgang: (D)lcdpuffer

I1SollZumLcdPuffer:
	lds		acc2,solli1
	lds		acc3,solli1+1
	rcall	binasc4    			; acc2,acc3 -> r3,4,5,6
	ldi		xl,low(lcdpuffer)
	ldi		xh,high(lcdpuffer)
	ldi		acc,0x90			; position
	st		x+,acc
	st		x+,r3
	st		x+,r4
	ldi		acc,'.'
	st		x+,acc
	st		x+,r5
	st		x+,r6
	ldi		acc,'A'
	st		x+,acc
	clr		acc
	st		x,acc
	ldi		lcdzeiger,0
	sbr		merker1,(1<<lcdaktiv)
	ret	
	
; ---------------------------------------------------
; I2SollZumLcdPuffer
; Eingang: (D)SollI2
; Ausgang: (D)lcdpuffer

I2SollZumLcdPuffer:
	lds		acc2,solli2
	lds		acc3,solli2+1
	rcall	binasc4    			; acc2,acc3 -> r3,4,5,6
	ldi		xl,low(lcdpuffer)
	ldi		xh,high(lcdpuffer)
	ldi		acc,0x94			; position
	st		x+,acc
	ldi		acc,' '
	st		x+,acc
	st		x+,r3
	st		x+,r4
	ldi		acc,'.'
	st		x+,acc
	st		x+,r5
	st		x+,r6
	clr		acc
	st		x,acc
	ldi		lcdzeiger,0
	sbr		merker1,(1<<lcdaktiv)
	ret	

	
; ------------------------------------------------
; pimaxzumlcdpuffer setzt den Text fr maximale W/I in den PCDpuffer
; Eingang: (D)leistungsstufe
; Ausgang: (D)lcdpuffer 

pimaxzumlcdpuffer:
	ldi		zl,low(txtzeile30*2)
	ldi		zh,high(txtzeile30*2)
	lds		acc,leistungsstufe
	ldi		acc2,10
	mul		acc,acc2			; acc,acc2 -> r1,R0 (HW/NW)
	add		zl,r0
	adc		zh,r1
	ldi		xl,low(lcdpuffer)
	ldi		xh,high(lcdpuffer)
	ldi		acc,0x88			; position
	st		x+,acc
	ldi		lcdzeiger,10
pimax1:
	lpm		acc,z+
	st		x+,acc
	dec		lcdzeiger
	brne	pimax1
	sbr		merker1,(1<<lcdaktiv)
	ret

; ---------------------------------------------------
; IstZumLcdPuffer, gemessene Spannung und Strom zum lcdpuffer
; Eingang: (D)istu, (D)isti
; Ausgang: (D)lcdpuffer

IstZumLcdPuffer:
	lds		acc2,istu
	lds		acc3,istu+1
	rcall	binasc4    			; acc2,acc3 -> r3,4,5,6
	ldi	xl,low(lcdpuffer)
	ldi	xh,high(lcdpuffer)
	ldi		acc,0x98			; position
	st		x+,acc
	mov		acc,r3
	cpi		acc,'0'				; hchste Stelle = 0?
	breq	izlp1				; JA
	st		x+,r3
	st		x+,r4
	st		x+,r5
	ldi		acc,'V'
	st		x+,acc
	ldi		acc,' '
	st		x+,acc
	rjmp	izlp2
izlp1:
	st		x+,r4
	st		x+,r5
	ldi		acc,'.'
	st		x+,acc
	st		x+,r6
	ldi		acc,'V'
	st		x+,acc
izlp2:
	ldi		acc,' '
	st		x+,acc
	lds		acc2,isti
	lds		acc3,isti+1
	rcall	binasc4    			; acc2,acc3 -> r3,4,5,6
	st		x+,r3
	st		x+,r4
	ldi		acc,'.'
	st		x+,acc
	st		x+,r5
	st		x+,r6
	ldi		acc,'A'
	st		x+,acc
	clr		acc
	st		x+,acc
	ldi		lcdzeiger,0
	sbr		merker1,(1<<lcdaktiv)
	ret	
	
; ---------------------------------------------------
; PistZumLcdPuffer
; Eingang: (D)istu (D)isti
; Ausgang: (D)lcdpuffer

PistZumLcdPuffer:
; (D)istu (in 10tel V) mal (D)isti (in 100tel A) = 1000tel Watt
	ldi		yl,low(aritin)
	ldi		yh,high(aritin)
; U nach aritin
	clr		acc
	st		y,acc
	lds		acc,istu
	sts		aritin+1,acc		
	lds		acc,istu+1
	sts		aritin+2,acc		
	ldi		zl,low(aritout)
	ldi		zh,high(aritout)
; I nach aritout
	clr		acc
	st		z,acc
	lds		acc,isti
	sts		aritout+1,acc		
	lds		acc,isti+1
	sts		aritout+2,acc
; U * I = P in 1000tel W		
	rcall	flpmultipl			; (Y) * (Z) = (z)
; Kehrwert von 1000
	clr		acc
	st		y,acc
	ldi		acc,high(1000)
	std		y+1,acc 
	ldi		acc,low(1000)
	std		y+2,acc
	rcall	kehrwert			; (y) -> (y)
; mit Kehrwert multiplizieren = durch 1000 teilen
	rcall	flpmultipl			; (Y) * (Z) = (z)
; Exponent auf 0	
	clr		acc
	rcall	expkorr				; acc,(z) -> (z)
	ldd		acc2,z+1
	ldd		acc3,z+2
	rcall	binasc4    			; acc2,acc3 -> r3,4,5,6
	ldi		xl,low(lcdpuffer)
	ldi		xh,high(lcdpuffer)
	ldi		acc,0x8d
	st		x+,acc
	ldi		acc,'P'
	st		x+,acc
	ldi		acc,'='
	st		x+,acc
	st		x+,r4
	st		x+,r5
	st		x+,r6
	ldi		acc,'W'
	st		x+,acc
	clr		acc
	st		x+,acc
	ldi		lcdzeiger,0
	sbr		merker1,(1<<lcdaktiv)
	ret	

; ---------------------------------------------------
; TempZumLcdPuffer  Temperatur am Khlkrper anzeigen
; Eingang: (D)temperatur 972 digit fr 100C
; Ausgang: (D)lcdpuffer

TempZumLcdPuffer:
	lds		acc2,temperatur
	lds		acc3,temperatur+1
	rcall	binasc4    			; acc2,acc3 -> r3,4,5,6
	ldi		xl,low(lcdpuffer)
	ldi		xh,high(lcdpuffer)
	ldi		acc,0x9e
	st		x+,acc
	ldi		acc,' '
	st		x+,acc
	st		x+,r4
	st		x+,r5
	ldi		acc,'a'-1
	st		x+,acc
	clr		acc
	st		x,acc
	ldi		lcdzeiger,0
	sbr		merker1,(1<<lcdaktiv)
	ret	

; ---------------------------------------------------
; ?ReglerZumLcdPuffer u- oder I-Regler-Symbol anzeigen
; Eingang: (D)inbytec
; Ausgang: (D)lcdpuffer

UReglerZumLcdPuffer:
	ldi		xl,low(lcdpuffer)
	ldi		xh,high(lcdpuffer)
	ldi		acc,0x83
	st		x+,acc
	ldi		acc,' '
	st		x+,acc
	lds		acc2,inbytec
	sbrc	acc2,uregleraktiv
	ldi		acc,4
	st		x+,acc
	rjmp	rzlp1
	
IReglerZumLcdPuffer:
	ldi		xl,low(lcdpuffer)
	ldi		xh,high(lcdpuffer)
	ldi		acc,0x93
	st		x+,acc
	ldi		acc,' '
	st		x+,acc
	lds		acc2,inbytec
	sbrs	acc2,uregleraktiv
	ldi		acc,4
	st		x+,acc
rzlp1:
	clr		acc
	st		x,acc
	ldi		lcdzeiger,0
	sbr		merker1,(1<<lcdaktiv)
	ret	
			
